import { GetService, ListService, NestedCreateService, NestedListService, UpdateService, BulkUpdateService, CreateService, DeleteService } from "./service-factory";
declare type BulkUpdateServiceHook<TRecord, TPathParams> = () => {
    update: BulkUpdateService<TRecord, TPathParams>;
};
declare type CreateServiceHook<TRecord> = () => {
    create: CreateService<TRecord>;
};
declare type DeleteServiceHook = () => {
    delete: DeleteService;
};
declare type GetServiceHook<TRecord, TPathParams, TQueryParams = undefined> = () => {
    get: GetService<TRecord, TPathParams, TQueryParams>;
};
declare type ListServiceHook<TRecord, TQueryParams> = () => {
    list: ListService<TRecord, TQueryParams>;
};
declare type NestedCreateServiceHook<TRecord, TPathParams> = () => {
    create: NestedCreateService<TRecord, TPathParams>;
};
declare type NestedListServiceHook<TRecord, TPathParams, TQueryParams> = () => {
    list: NestedListService<TRecord, TPathParams, TQueryParams>;
};
declare type UpdateServiceHook<TRecord, TPathParams> = () => {
    update: UpdateService<TRecord, TPathParams>;
};
declare const ServiceHookFactory: {
    useBulkUpdate<TRecord, TPathParams>(recordType: new () => TRecord, resourceEndpoint: string): BulkUpdateServiceHook<TRecord, TPathParams>;
    useCreate<TRecord_1 extends any>(recordType: new () => TRecord_1, baseEndpoint: string): CreateServiceHook<TRecord_1>;
    useDelete(resourceEndpoint: string): DeleteServiceHook;
    useGet<TRecord_2, TPathParams_1, TQueryParams = undefined>(recordType: new () => TRecord_2, resourceEndpoint: string): GetServiceHook<TRecord_2, TPathParams_1, TQueryParams>;
    useList<TRecord_3, TQueryParams_1>(recordType: new () => TRecord_3, baseEndpoint: string): ListServiceHook<TRecord_3, TQueryParams_1>;
    useNestedCreate<TRecord_4 extends any, TPathParams_2>(recordType: new () => TRecord_4, baseEndpoint: string): NestedCreateServiceHook<TRecord_4, TPathParams_2>;
    useNestedList<TRecord_5, TPathParams_3, TQueryParams_2>(recordType: new () => TRecord_5, baseEndpoint: string): NestedListServiceHook<TRecord_5, TPathParams_3, TQueryParams_2>;
    useUpdate<TRecord_6, TPathParams_4>(recordType: new () => TRecord_6, resourceEndpoint: string): UpdateServiceHook<TRecord_6, TPathParams_4>;
};
export { BulkUpdateServiceHook, CreateServiceHook, DeleteServiceHook, GetServiceHook, ListServiceHook, NestedCreateServiceHook, NestedListServiceHook, ServiceHookFactory, UpdateServiceHook, };
